'use strict';

// create a simple bitset around a single integer
function makeBitset(initial_value) {
  let value = Number.isInteger(initial_value) ? initial_value : 0;

  const make_mask = function(index){ return 1 << index; };

  const get_bit = function(index) {
    const mask = make_mask(index);
    const only_bit = value & mask;
    return only_bit !== 0;
  };

  const set_bit = function(index, should_set) {
    const mask = make_mask(index);
    if (should_set) {
      value |= mask;
    }
    else {
      value &= ~mask;
    }
  };

  const get = function() { return value; };
  const set = function(val){ value = val; };

  return {
    get_bit:get_bit,
    set_bit:set_bit,
    get:get,
    set:set
  };
}
