const OpticalModes = {
  ADAT: 0,
  TOSlink: 1
};

const OpticalExpanderMode = {
  kDisabled:0,
  kEnabled:1
};

const MixBusTypes = {
  Main: "Main",
  Phones: "Phones",
  Line: "Line",
  Reverb: "Reverb"
};

const kSampleRates = [
  { v:44100, l:"44100" },
  { v:48000, l:"48000" },
  { v:88200, l:"88200" },
  { v:96000, l:"96000" },
  { v:176400, l:"176400" },
  { v:192000, l:"192000" }
];

const kHostBuffers1x = [
  { v:16, l:"16" },
  { v:32, l:"32" },
  { v:64, l:"64" },
  { v:128, l:"128" },
  { v:256, l:"256" },
  { v:512, l:"512" },
  { v:1024, l:"1024" },
  { v:2048, l:"2048" },
  { v:4096, l:"4096"}
];

const kHostBuffers2x = [
  { v:16, l:"16" },
  { v:32, l:"32" },
  { v:64, l:"64" },
  { v:128, l:"128" },
  { v:256, l:"256" },
  { v:512, l:"512" },
  { v:1024, l:"1024" },
  { v:2048, l: "2048"}
];

const kHostBuffers4x = [
  { v:16, l:"16" },
  { v:32, l:"32" },
  { v:64, l:"64" },
  { v:128, l:"128" },
  { v:256, l:"256" },
  { v:512, l:"512" },
  { v:1024, l:"1024" }
];

const kUIMeterFPSs = [
  { v:15, l:"Slow" },
  { v:30, l:"Medium" },
  { v:60, l:"Fast" }
];

const kExtraSafetyOffset1X =  [
  { v:0, l:"Lowest Latency" },
  { v:1, l:"Default" }
];

const kMixInputMetersMode =  [
  { v:0, l:"Pre-Fader" },
  { v:1, l:"Post-Fader" }
];
const kHostOutputMixMode =  [
  { v:0, l:"Default" },
  { v:1, l:"Additional" }
];

const kNetControlEnableValues = [
  { v:0, l:"Disabled"},
  { v:1, l:"Enabled"}
];

const kOpticalExpanderEnableValues = [
  { v:OpticalExpanderMode.kDisabled, l:"Disabled"},
  { v:OpticalExpanderMode.kEnabled, l:"Enabled"}
];

const kMIDIThruValues = [
  { v:0, l: "Disabled"},
  { v:1, l: "Enabled"}
];

const kWorkClockOutValues = [
  { v:1, l: "Out"},
  { v:0, l: "Thru"}
];

// Property types:
const kTString = "S"; //    String "S": v is an array of string
const kTInt32 = "I";  //    Int32 "I": v is an array of int32
const kTFloat = "F";  //    Float "F": v is an array of float (8.24 float on device)
const kTInt16 = "I16";//    Int16 "16": v is an array of bytes
const kTByte = "B";   //    Int8 "B": v is an array of bytes
const kTArray = "A";  //    Array of Bytes

const kMetersID = 6000;
const kProxyStatusID = 0xFFFF;
const kProxyMessageID = 0xFFFE;   // Message between CM5 and Proxy Server, not for the device

const DeviceTypes = Object.freeze({
  None:"None",
  k828:"828",
  UltraLite:"UltraLite-mk5"
});

const DeviceModels = Object.freeze({
  k828:"828",
  UltraLite:"UL"
});

function DeviceTypeFromModel(model) {
  if (model.startsWith(DeviceModels.UltraLite)) {
    return DeviceTypes.UltraLite;
  }
  else if (model.startsWith(DeviceModels.k828)) {
    return DeviceTypes.k828;
  }
  else {
    return DeviceTypes.None;
  }
}

// The version of the datastore api I support
const kDataStoreAPIVersion = 9;
const kDataStoreAPIVersionUnknown = -1;
