'use strict';

////////// constants for the app //////////////

// throttling of refresh and meters
const kMaxRefreshInterval = 1/60; // if you want to throttle drawing
const kMaxMeterInterval = 1/30; // if you want to throttle meter drawing
var kCanvasScale = 2;


////////// global decls //////////////
var isIOS = false;
var isMobile = false;

const kMixBG = "rgb(35, 38, 44)";
const kBusStripBG = "rgb(47, 52, 59)";
const kBlackBG = "black"
const kNavBtnGrey = "rgb(70, 74, 83)";

// dimensions
const kFaderL = 50;
const kBusStripW = 130;
const kBusStripWSmall = 50;
const kChStripW = 105;
const kFxChStripW = 1.5 * kChStripW;
const kNumChStrips = 38;
const kTabSelW = 220;
const kThumbH = 55;
const kFxThumbH = 1.5 * kThumbH;
const kFaderCapRadius = 20;

const kTabEv = "tabEv";
const kHome = "kHome";
const kDev = "kDev";
const kISetup = "kISetup";
const kOSetup = "kOSetup";
const kAdv = "kAdv";
const kTabBG = "rgb(17, 21, 24)";
const kTabTxt = "rgb(127,127,127)";
const kTabTxtSel = "white";
const kTabSel = "rgb(37,38,39)";
const kMenuBlue = "rgb(20,122,255)";

const kToggleBlue = "rgb(52, 141, 221)";
const kToggleYellow = "rgb(234, 226, 23)";
const kToggleRed = "rgb(207, 31, 37)";
const kMeterTickColor = "rgb(108, 109, 110)";
const kToggleDefault = "rgb(158, 159, 160)";

const kEQColors = [
  'rgb(0, 255, 251)',
  'rgb(187, 157, 255)',
  'rgb(167, 44, 88)',
  'rgb(1, 114, 241)',
];

const kMeterBlue = "rgb(52, 141, 221)";
const kMeterLightBlue = "rgb(103, 170, 233)";
const kMeterOrange = "rgb(255, 194, 131)";
const kGridColor = "rgb(63, 71, 82)";
const kEQLabel = "rgb(116, 117, 135)";
const kEQValue = "rgb(185, 191, 217)";
const kEQControlGray = "rgba(99, 105, 120, 0.7)";
const kEQCurveColors = [
  'rgba(0, 255, 251, 0.3)',
  'rgba(187, 157, 255, 0.3)',
  'rgba(167, 44, 88, 0.3)',
  'rgba(1, 114, 241, 0.3)',
];

const kKeyEntryInactive = "rgb(20, 100, 155)";
const kKeyEntryActive = "rgb(56, 155, 255)";

const kDynCtrlBG = "rgb(35, 38, 44)";
const kGateCtrl = "rgb(0, 207, 213)";
const kGateCtrlDisabled  = "rgba(0, 207, 213, 0.2)";
const kCompCtrl = "rgb(239,183,28)";
const kCompCtrlDisabled  = "rgba(239, 183, 28, 0.2)";
const kGRMeter = "rgb(225, 65, 65)";
const kLMeter = "rgb(78, 165, 255)";

const kEmptyBG = "rgb(27, 29, 28)";

const kFxEditBG = 'rgb(18, 22, 25)';
const kFxHeight = 608;
const kFxWidth = 1080;

const kBusEQFxType = "EQBus";
const kEQFxType = "EQ";
const kDynamicsFxType = "Dynamics";
const kReverbFxType = "Reverb";

const kDimmedAlpha = 0.2; // The alpha value when a UI control is "dimmed"

// consts for the location of input meter indexes
const kMIPreGate = 0; // post eq
const kMIGateReduction = 1;
const kMIPreComp = 2; // post eq or post post gate
const kMICompReduction = 3;
const kMIPostFx = 4;

var kScrollBarSize = 40;

const kZIndexMixer = 100;
const kZIndexDiagnostics = 1400;
const kZIndexUpdater = 1600;
const kZIndexScrollDiv = 2000;
const kZIndexDiscoveryGestureListener = kZIndexScrollDiv + 1;
const kZIndexDiscovery = 3000;
const kZIndexConsteMenuCanceler = kZIndexDiscovery + 1
const kZIndexContextMenu = kZIndexConsteMenuCanceler + 1;
const kZIndexPassword = kZIndexContextMenu + 1;


const kDiscoverySlideDuration = 250;
const kDiscoverySwipeDuration = 150;

const kDiscoveryGestureLeftEdgeInset = 10; // Pixels from left edge of screen where the swipe open gesture can start.
const kDiscoveryGestureRightEdgeInset = 30; // Pixels from right edge of screen where the swipe close gesture can start.

const kStrDimRefText = "ABCDEFGHIJKLMNOPQRXTUVWXYZabcdefghijklmnopqrxtuvwxyz0123456789";

var gApp; // Need a global to reference from native app container
