

class PWCache {
	constructor() {}

	getPassword(serial) {
    let d = this.dictionary();

    if (d.hasOwnProperty(serial))
      return d[serial];
    return undefined;
	}

	savePassword(serial, pw) {
    let d = this.dictionary();
    d[serial] = pw;

    try {
      let ser = JSON.stringify(d);
      localStorage.setItem("passwords", ser);
    }
    catch (TypeError) {
      console.log("Failed to save device password");
    }
	}

	deletePassword(serial) {
    let d = this.dictionary();
    if (d.hasOwnProperty(serial)) {
      delete d[serial];
      try {
        let ser = JSON.stringify(d);
        localStorage.setItem("passwords", ser);
      }
      catch (e) {
        console.log("Failed to save device password");
      }
    }
	}

	clear() {
    localStorage.removeItem("passwords");
	}

	dictionary() {
   let pw_ser = localStorage.getItem("passwords");
    if (pw_ser == null) {
      return {};
    }

    try {
      let cache = JSON.parse(pw_ser);
      if (cache == null) {
        return {};
      }
      return cache;
    }
    catch(e) {}

    return {};
	}

};